package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# 一般設定モジュール
# GeneralSetting.pm ver1.1.4
# Copyright (C) 1999-2019 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2019-06-27
######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    no warnings qw(once);
    my $this = shift;

    #数字チェック
    $check::num{'ipStopper'}  = '連続入力の制限';
    $check::num{'rewindable'} = '更新の保存数';

    #チェックボックス
    push( @check::checkbox, 'data', 'skipConfirmation' );
    if ( $default::type && $default::type eq 'order' ) {
        push( @check::checkbox,
            'autoRegister',     'mailonly',
            'dcUnmaintainable', 'dcArchiveEnabled' );
        $check::num{'dcPendingTimeout'} =
          'デジタルコンテンツ発注後保存期間';
        $check::num{'dcLifetime'} =
          'デジタルコンテンツダウンロード期間';
        $check::num{'dcMaxDownload'} =
          'デジタルコンテンツダウンロード回数';
        $check::detag{'itemname'} = '「商品」の呼称';
    }
    else {
        push( @check::checkbox,
            'siteRSSEnabled', 'masterRSSEnabled',    'RSSEnabled',
            'autoRegister',   'oneEmailToOneRecord', 'syncRegister' );
    }

    push( @check::notag, 'description' );
    $check::imagefile{'og'} = 'og:image';
    $check::ogimage{'og'}   = 1;
    return;
}

######################################################################
# 設定環境2
sub is_database_cgi ($) {
    my $this = shift;
    return 1;
}

sub sub_set_preferences ($) {
    my $this = shift;
    $cgi::enctype_multipart = 1;
    $default::file = '.' if !defined $default::file || $default::file eq '';
    $preference::filedir{'og'} = $default::file; #画像保存ディレクトリ
}

######################################################################
# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;
    print '<fieldset><legend>メタデータ</legend>';
    print '<fieldset><legend>og:image</legend>';
    $this->print_image_upload_form( 'og', 'og', \%main::data );
    print '</fieldset>';
    print
      '<fieldset><legend><label for="data:description">説明</label></legend>';
    print
'<textarea name="data:description" id="data:description" cols="56" rows="6" wrap="soft" title="メタデータに埋め込む説明を設定します。">'
      . (
        ( defined $main::data{'description'} )
        ? $main::data{'description'}
        : ''
      ) . '</textarea>';
    print
'<div class="note">メタデータに埋め込む説明を設定します。</div></fieldset>';
    print '</fieldset>';

    #RSS更新設定
    if ( !$default::type || $default::type ne 'order' ) {
        print
'<fieldset><legend><label for="default_m">デフォルトの表示</label></legend>';
        print $this->mk_select_menu(
            'default_m', '', '', $default::m,
            'Index'       => '検索',
            'TableViewer' => 'テーブル表示',
            'TileViewer'  => 'タイル表示',
            'GMapViewer'  => 'Googleマップ表示',
            'Gate'        => '修正レコード選択ページ',
            'DetailGate'  => '詳細表示選択ページ',
        );
        print
'<div class="note">検索やカテゴリーリストで参照される「表示形式のデフォルト」については「ページレイアウト/共通部品設定」で設定します。</div></fieldset>';
    }

    print '<fieldset><legend>データ入力設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
'<td class="field-name"><span class="datatitle">連続入力の制限</span></td>';
    print
'<td class="field"><label><input type="number" size="3" maxlength="3" name="data:ipStopper" value="'
      . $this->escape( $main::data{'ipStopper'} )
      . '" /> 秒間、同一IPからの入力を禁止する</label></td>';
    print '</tr>';

    if ( !$default::type || $default::type ne 'order' ) {
        print '<tr>';
        print
'<td class="field-name"><span class="datatitle">入力内容の確認</span></td>';
        print
'<td class="field"><label><input type="checkbox" name="data:skipConfirmation" id="data:skipConfirmation" value="1"'
          . ( ( $main::data{'skipConfirmation'} ) ? 'checked="checked"' : '' )
          . ' /> 内容確認を省略する</label></td>';
        print '</tr>';
    }
    print '<tr>';
    print
'<td class="field-name"><label for="data:mail">データ入力の通知</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'data:mail',
'新規入力または3時間以上間隔のあいた更新をメールで通知します。',
        '', $main::data{'mail'},
        ''       => '通知機能停止',
        'master' => '管理人に通知',
        'owners' => '管理人・共同オーナーに通知',
        'staff'  => '管理人・共同オーナー・スタッフに通知'
    );
    print '<label><input type="checkbox" name="data:data" value="1"'
      . ( ( $main::data{'data'} ) ? ' checked="checked"' : '' )
      . ' /> 入力されたデータを本文に含む</label>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
'<td class="field-name"><span class="datatitle">更新の保存</span></td>';
    print
'<td class="field"><label>過去の更新を<input type="number" size="3" maxlength="3" name="data:rewindable" value="'
      . $this->escape( $main::data{'rewindable'} )
      . '" /> 件まで自動保存する。</label>';
    print
'<div><label><input type="checkbox" name="clear_archives" value="1" /> 過去の更新を全て削除する。</label></div>';
    print '</td></tr>';
    print '</tbody>';
    print '</table></fieldset>';

    if ( $default::type && $default::type eq 'order' ) {
        print
'<fieldset><legend>メールアドレスの自動登録(パスワード自動発行)</legend>';
        print '<ol class="checkbox">';
        print
          '<li><label><input type="checkbox" name="data:autoRegister" value="1"'
          . ( ( $main::data{'autoRegister'} ) ? ' checked="checked"' : '' )
          . ' /> 「パスワード登録」の「アクセス権設定」に関わらず、「代表メールフィールド」に入力されたメールアドレスを自動登録しパスワードを発行する</label></li>';
        print '</ol>';
        print '</fieldset>';

        print
'<fieldset><legend><label for="data:itemname">「商品」の呼称</label></legend>';
        print
'<input type="text" name="data:itemname" id="data:itemname" size="40" title="「商品」の呼称を設定します。" value="'
          . (
            ( defined $main::data{'itemname'} )
            ? $main::data{'itemname'}
            : ''
          ) . '" placeholder="商品、レッスン、イベント 等" />';
        print
'<div class="note">設定なしで「商品」と表示されます。</div>';
        print '</fieldset>';

        print '<fieldset><legend>受注データの保存</legend>';
        print
'<label><input type="checkbox" name="data:mailonly" id="data:mailonly" value="1"'
          . ( ( $main::data{'mailonly'} ) ? 'checked="checked"' : '' )
          . ' /> 受注データを保存しない <span class="note">(発注メールのみ送信されます)</span></label>';
        print
'<div class="warning">デジタルコンテンツのダウンロード販売を行う場合は、支払い後ダウンロードURLを伝えるために受注データを保存する必要があります。</div>';
        print '</fieldset>';

        print
'<fieldset><legend>デジタルコンテンツの保存期間</legend>';
        print '<ul>';
        print
'<li><label>発注後、代金が支払われないまま <input type="number" size="3" maxlength="3" name="data:dcPendingTimeout" value="'
          . $this->escape( $main::data{'dcPendingTimeout'} )
          . '" /> 日以上経過したとき、デジタルコンテンツを削除する(設定なしで30日)。</label></li>';
        print
'<li><label>代金が支払われた後、<input type="number" size="3" maxlength="3" name="data:dcLifetime" value="'
          . $this->escape( $main::data{'dcLifetime'} )
          . '" /> 日以上経過したとき、デジタルコンテンツを削除する(設定なしで30日)。</label></li>';
        print
'<li><label>代金が支払われた後、最大 <input type="number" size="3" maxlength="3" name="data:dcMaxDownload" value="'
          . $this->escape( $main::data{'dcMaxDownload'} )
          . '" /> 回のダウンロードを許可する(設定なしで5回)。</label></li>';
        print '</ul>';
        print '</fieldset>';
        print '<fieldset><legend>保存容量の節約</legend>';
        print
          '<label><input type="checkbox" name="data:dcUnmaintainable" value="1"'
          . ( ( $main::data{'dcUnmaintainable'} ) ? ' checked="checked"' : '' )
          . ' /> デジタルコンテンツの購入時データを保持しない</label>';
        print
'<div class="warning">このオプションを有効にすると保存容量を節約できますが、デジタルコンテンツが削除されたときそのファイルをダウンロードできなくなります。また購入後デジタルコンテンツがアップデートされた場合、購入時のバージョンではなく最新のバージョンがダウンロードされます。</div>';
        print '</fieldset>';

        if ( eval 'use Archive::Zip;1;' ) {
            print
              '<fieldset><legend>デジタルコンテンツの圧縮</legend>';
            print
'<label><input type="checkbox" name="data:dcArchiveEnabled" value="1"'
              . (
                ( $main::data{'dcArchiveEnabled'} )
                ? ' checked="checked"'
                : ''
              )
              . ' /> ダウンロードファイルを一つの ZIP 圧縮ファイルにまとめる</label>';
            print '</fieldset>';
        }
    }
    else {
        print
'<fieldset><legend>メールアドレスの自動登録(パスワード自動発行)</legend>';
        print '<ol class="checkbox">';
        print
          '<li><label><input type="checkbox" name="data:autoRegister" value="1"'
          . ( ( $main::data{'autoRegister'} ) ? ' checked="checked"' : '' )
          . ' /> 「パスワード登録」の「アクセス権設定」に関わらず、「代表メールフィールド」に入力されたメールアドレスを自動登録しパスワードを発行する</label></li>';
        print
'<li><label><input type="checkbox" name="data:oneEmailToOneRecord" value="1"'
          . (
            ( $main::data{'oneEmailToOneRecord'} )
            ? ' checked="checked"'
            : ''
          )
          . ' title="同じメールアドレスを含むレコードが既に存在するとき、そのメールアドレスが未登録の場合、古いレコードが削除されます。そのメールアドレスが登録されている場合は、新しい入力を拒絶します。" /> 一つのメールアドレスにつき、一つのレコードに制限する</label>';
        print
'<ol><li><label><input type="checkbox" name="data:syncRegister" value="1"'
          . ( ( $main::data{'syncRegister'} ) ? ' checked="checked"' : '' )
          . ' /> レコード削除時に、「代表メールフィールド」に入力されたメールアドレスの登録を抹消する</label></li></ol></li>';
        print '</ol>';
        print
'<div class="warning">「読み込み」および「データベース消去」実行時には上記オプションは動作しません。</div>';
        print '</fieldset>';
    }

#$main::data{'English'} = $default::english if !defined $main::data{'English'} || $main::data{'English'} eq '';
#$main::data{'English'} = '0' if $main::data{'English'} == 0;
#print '<fieldset><legend><label for="data:English">閲覧ページ英語表示</label></legend>';
#print $this->mk_select_menu(
#	'data:English','','',$main::data{'English'},
#	'1'		=>		'英語表示',
#	'0'		=>		'日本語表示'
#);
#print '</fieldset>';

    #RSS更新設定
    if ( !$default::type || $default::type ne 'order' ) {
        print '<fieldset><legend>RSS更新設定</legend>';
        print '<fieldset><legend>入力時に更新するRSS</legend>';
        print '<ol class="checkbox">';
        print
'<li><label><input type="checkbox" name="data:siteRSSEnabled" value="1"'
          . ( ( $main::data{'siteRSSEnabled'} ) ? ' checked="checked"' : '' )
          . ' /> '
          . (
            ( -f '../../index.xml' )
            ? '<a href="../../index.xml" target="_blank">サイト全体の新着情報(RSS)</a>'
            : 'サイト全体の新着情報(RSS)'
          ) . 'を更新する</label></li>';
        print
'<li><label><input type="checkbox" name="data:masterRSSEnabled" value="1"'
          . ( ( $main::data{'masterRSSEnabled'} ) ? ' checked="checked"' : '' )
          . ' /> '
          . (
            (
                $default::master_file_dir
                  && -f $default::master_file_dir . '/index.xml'
            )
            ? '<a href="'
              . $default::master_file_dir
              . '/index.xml'
              . '" target="_blank">このデータベースの新着情報(RSS)</a>'
            : 'このデータベースの新着情報(RSS)'
          ) . 'を更新する</label></li>';
        print
          '<li><label><input type="checkbox" name="data:RSSEnabled" value="1"'
          . ( ( $main::data{'RSSEnabled'} ) ? ' checked="checked"' : '' )
          . ' /> '
          . (
            ( $default::file && -f $default::file . '/index.xml' )
            ? '<a href="'
              . $default::file
              . '/index.xml'
              . '" target="_blank">カテゴリーごとの新着情報(RSS)</a>'
            : 'カテゴリーごとの新着情報(RSS)'
          ) . 'を更新する</label></li>';
        print '</ol>';
        print '</fieldset>';
        print '</fieldset>';
    }
    return;
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    if (
           ( !$default::type || $default::type ne 'order' )
        && defined $main::default_m
        && grep( $_ eq $main::default_m,
            'Index',      'TableViewer', 'TileViewer',
            'GMapViewer', 'Gate',        'DetailGate' )
        && $main::default_m ne $default::m
      )
    {
        my ( $data, $default_path, %key );
        %key = (
            'Index'       => 'index',
            'TableViewer' => 'viewer',
            'TileViewer'  => 'tile',
            'GMapViewer'  => 'gmap',
            'Gate'        => 'gate',
            'DetailGate'  => 'detailgate',
        );
        $default_path = './default.pl';
        $data = $this->read_file( $default_path, 1 );
        $data =~
          s/^[\x20\x09]*\$m[\x20\x09]*=[^;]*;/\$m = '$main::default_m';/gm;
        $data =~
s/^[\x20\x09]*\$k[\x20\x09]*=[^;]*;/\$k = '$key{$main::default_m}';/gm;
        if ( $this->write_file( $default_path, \$data, 1 ) ) {
            $default::m = $main::default_m;
        }
        else {
            push(
                @{ $this->{'dialog'} },
                'デフォルトの表示の変更に失敗しました。'
            );
        }
    }
    if ($main::clear_archives) {
        use File::Path;
        $this->clear_archives($default::file);
    }
    return;
}

sub clear_archives ($$) {
    my $this = shift;
    my $dir  = shift;
    local (*DIR);
    my @dirs = ();
    if ( -d $dir . '/archives.pending' ) {
        rmtree $dir . '/archives.pending';
    }
    if ( opendir( DIR, $dir ) ) {
        @dirs = grep( $_ !~ /^\./ && -d $dir . '/' . $_, readdir(DIR) );
        closedir(DIR);
    }
    foreach my $d ( @dirs ) {
        $this->clear_archives( $dir . '/' . $d );
    }
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定';
}

1;
